#include <stdlib.h>
#include <stdio.h>

#include "tree.h"

Tree *insert(Tree *t, int key, void *data_ptr) {
	Tree *new;
	Tree *aux, *anterior;

	new=(Tree*)malloc(sizeof(Tree));
	new->key=key;
	new->data_ptr=data_ptr;
	new->right=NULL;
	new->left=NULL;

	if (t==NULL) {
		t=new;
	}
	else {
		aux=t;
		anterior = NULL;
		while (aux != NULL) {
			anterior=aux;
			if (aux->key > key) 
				aux=aux->left;
			else
				aux=aux->right;
		}
		if (anterior->key < key)
			anterior->right=new;
		else
			anterior->left=new;
	}

	return t;
}

void wAnnotate(Tree *t) {
	WNode *new;

	if (t != NULL) {
		wAnnotate(t->left);
		wAnnotate(t->right);
		
		new=(WNode*)malloc(sizeof(WNode));
		new->data_ptr=t->data_ptr;
		t->data_ptr=(void *)new;

		new->weight=1;
		if (t->left != NULL)
			new->weight += ((WNode *) t->left->data_ptr)->weight;
		if (t->right != NULL)
			new->weight += ((WNode *) t->right->data_ptr)->weight;
	}
}

void *search(Tree *t, int key) {
	Tree *aux;

   	if (t==NULL) {
                return NULL;
        }
        else {
                aux=t;
                while ((aux != NULL)&&(aux->key != key)) {
                        if (aux->key > key) 
                                aux=aux->left;
                        else
                                aux=aux->right;
                }
		if (aux == NULL)
			return NULL;
		else 
			return aux->data_ptr;
        }
}

