#include <stdlib.h>
#include <stdio.h>

#include "tree.h"

Tree *insert(Tree *t, int key, void *data_ptr) {
	
	Tree *new;
	Tree *aux, *anterior_aux;

	new=(Tree*)malloc(sizeof(Tree));
	new->key=key;
	new->data_ptr=data_ptr;
	new->right=NULL;
	new->left=NULL;
	
	if (t==NULL) {
		t=new;
	}
	else {
		aux=t;
		anterior_aux=NULL;
		while (aux != NULL) {
			anterior_aux=aux;
			if (key>aux->key) 
				aux=aux->right;
			else
				aux=aux->left;
		}
		if (anterior_aux->key>key)
			anterior_aux->left=new;
		else
			anterior_aux->right=new;
	}

	return t;
}

void wAnnotate(Tree *t) {
	WNode *new;	

	if (t != NULL) {
		wAnnotate(t->right);
		wAnnotate(t->left);

		new=(WNode *)malloc(sizeof(WNode));

		new->data_ptr=t->data_ptr;
		t->data_ptr=(void *)new;

		new->weight=1;
		if (t->left != NULL)
			new->weight+=((WNode *)t->left->data_ptr)->weight;
		if (t->	right !=NULL)
			new->weight+=((WNode *)t->right->data_ptr)->weight;
	}

}

void *search(Tree *t, int key) {
	Tree *aux;

        if (t==NULL) {
                return NULL;
        }
        else {
                aux=t;
                while ((aux != NULL)&&(key != aux-> key)) {
                        if (key>aux->key) 
                                aux=aux->right;
                        else
                                aux=aux->left;
                }
		if (aux == NULL)
			return NULL;
		else
			return aux->data_ptr;
        }

}

